#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrRed
#property indicator_color2  clrBlue
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames       TimeFrame       = tf_cu;            // Time frame
extern int                TimeFrameCustom = 0;                // Custom time frame to use (if custom time frame used)
extern int                FractalPeriod   = 25;
extern ENUM_APPLIED_PRICE PriceHigh       = PRICE_HIGH;
extern ENUM_APPLIED_PRICE PriceLow        = PRICE_LOW;

double v1[];
double v2[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//
  
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,v1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159); SetIndexLabel(0,"Resistance");
   SetIndexBuffer(1,v2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159); SetIndexLabel(1,"Support");
   
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame==-99; 
    if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
    if (TimeFrame!=tf_cus)
          TimeFrame = MathMax(TimeFrame,_Period);
    else  TimeFrame = (enTimeFrames)TimeFrameCustom;
      
    IndicatorShortName(timeFrameToString(TimeFrame)+"  Fractals - adjustable price");
return(0);
}

//
//
//
//
//

int start()
{
   int k,i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { v1[0] = MathMin(limit+1,Bars-1); return(0); }

            
   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   { 
     int half = FractalPeriod/2;    
     for(i=limit; i>=0; i--) 
     {
        bool   found     = true;
        double compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
        for (k=1;k<=half;k++)
        {
            if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
            if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
        }
        if (found) v1[i] = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
        else       v1[i] = v1[i+1];

        //
        //
        //
        //
        //
      
        found     = true;
        compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);
        for (k=1;k<=half;k++)
        {
           if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
           if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
        }
        if (found) v2[i] = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);  
        else       v2[i] = v2[i+1];
     }
   return(0);
   }
  
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          v1[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,FractalPeriod,PriceHigh,PriceLow,0,y);
          v2[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,FractalPeriod,PriceHigh,PriceLow,1,y);
   }
return(0);
}
 
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
